# incorporeal-cms

A lightweight static site generator software for Markdown-based sites.

## Installation and Usage

I recommend getting a release from <https://git.incorporeal.org/bss/incorporeal-cms/releases> and
installing the Python package in a virtualenv. Something like the following should suffice:

```
% virtualenv --python=python3.9 env-py3.9
% source env-py3.8/bin/activate
% pip install -U pip
% pip install incorporeal-cms
% incorporealcms-build ./path/to/instance ./path/to/output/www/root
```

This will generate the directory suitable for serving by e.g. Nginx.

## Generating a Site

Put content, notably Markdown content, inside `./your-instance/pages/` and go.

* Markdown files (ending in `.md`) are rendered via Python-Markdown as .html files, other
  files generally left alone and copied to the static site.
* Directory paths (e.g. `/dir/`) can be served via a `/dir/index.md` file.
* Symlinks to files are retained and handled per the web server's configuration.
* Non-Markdown files are copied directly, so images, etc., can be referenced naturally.

The application is further configured within `./your-instance/config.json`, and content is served

## Configuration

I've tried to keep the software agnostic to my personal domains, logos, etc. There are some settings
you are probably interested in tweaking, by specifying new values in
`incorporealcms-instance/config.json`:

* `TITLE_SUFFIX` is appended to the title of every page, separated from other title content by a
  dash.
* `CONTACT_EMAIL` is referred to in error templates.
* `FAVICON` supplies the image used in browser tabs and that kind of thing.

If I missed anything, please let me know.

## Development and Contributing

Improvements, new plugins, and etc. are all welcome.

I'm reachable on the fediverse, over email, or on Discord, but if you're looking for an option I prefer, I maintain an
IRC channel, `#incorporeal-cms`, on [my IRC network, Randomus](https://randomus.net/) if you would like a place to hang
out and discuss issues and features and whatnot.

## Author and Licensing

Written by and copyright (C) 2025 Brian S. Stephan <bss@incorporeal.org>.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
